// Code generated by MockGen. DO NOT EDIT.
// Source: gitlab.com/gitlab-org/cluster-integration/gitlab-agent/v17/internal/module/modshared (interfaces: RPCAPI,API)
//
// Generated by this command:
//
//	mockgen -typed -destination api.go -package mock_modshared gitlab.com/gitlab-org/cluster-integration/gitlab-agent/v17/internal/module/modshared RPCAPI,API
//

// Package mock_modshared is a generated GoMock package.
package mock_modshared

import (
	context "context"
	reflect "reflect"

	fieldz "gitlab.com/gitlab-org/cluster-integration/gitlab-agent/v17/internal/tool/fieldz"
	retry "gitlab.com/gitlab-org/cluster-integration/gitlab-agent/v17/internal/tool/retry"
	gomock "go.uber.org/mock/gomock"
	zap "go.uber.org/zap"
)

// MockRPCAPI is a mock of RPCAPI interface.
type MockRPCAPI struct {
	ctrl     *gomock.Controller
	recorder *MockRPCAPIMockRecorder
}

// MockRPCAPIMockRecorder is the mock recorder for MockRPCAPI.
type MockRPCAPIMockRecorder struct {
	mock *MockRPCAPI
}

// NewMockRPCAPI creates a new mock instance.
func NewMockRPCAPI(ctrl *gomock.Controller) *MockRPCAPI {
	mock := &MockRPCAPI{ctrl: ctrl}
	mock.recorder = &MockRPCAPIMockRecorder{mock}
	return mock
}

// EXPECT returns an object that allows the caller to indicate expected use.
func (m *MockRPCAPI) EXPECT() *MockRPCAPIMockRecorder {
	return m.recorder
}

// HandleIOError mocks base method.
func (m *MockRPCAPI) HandleIOError(arg0 *zap.Logger, arg1 string, arg2 error) error {
	m.ctrl.T.Helper()
	ret := m.ctrl.Call(m, "HandleIOError", arg0, arg1, arg2)
	ret0, _ := ret[0].(error)
	return ret0
}

// HandleIOError indicates an expected call of HandleIOError.
func (mr *MockRPCAPIMockRecorder) HandleIOError(arg0, arg1, arg2 any) *MockRPCAPIHandleIOErrorCall {
	mr.mock.ctrl.T.Helper()
	call := mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "HandleIOError", reflect.TypeOf((*MockRPCAPI)(nil).HandleIOError), arg0, arg1, arg2)
	return &MockRPCAPIHandleIOErrorCall{Call: call}
}

// MockRPCAPIHandleIOErrorCall wrap *gomock.Call
type MockRPCAPIHandleIOErrorCall struct {
	*gomock.Call
}

// Return rewrite *gomock.Call.Return
func (c *MockRPCAPIHandleIOErrorCall) Return(arg0 error) *MockRPCAPIHandleIOErrorCall {
	c.Call = c.Call.Return(arg0)
	return c
}

// Do rewrite *gomock.Call.Do
func (c *MockRPCAPIHandleIOErrorCall) Do(f func(*zap.Logger, string, error) error) *MockRPCAPIHandleIOErrorCall {
	c.Call = c.Call.Do(f)
	return c
}

// DoAndReturn rewrite *gomock.Call.DoAndReturn
func (c *MockRPCAPIHandleIOErrorCall) DoAndReturn(f func(*zap.Logger, string, error) error) *MockRPCAPIHandleIOErrorCall {
	c.Call = c.Call.DoAndReturn(f)
	return c
}

// HandleProcessingError mocks base method.
func (m *MockRPCAPI) HandleProcessingError(arg0 *zap.Logger, arg1 string, arg2 error, arg3 ...fieldz.Field) {
	m.ctrl.T.Helper()
	varargs := []any{arg0, arg1, arg2}
	for _, a := range arg3 {
		varargs = append(varargs, a)
	}
	m.ctrl.Call(m, "HandleProcessingError", varargs...)
}

// HandleProcessingError indicates an expected call of HandleProcessingError.
func (mr *MockRPCAPIMockRecorder) HandleProcessingError(arg0, arg1, arg2 any, arg3 ...any) *MockRPCAPIHandleProcessingErrorCall {
	mr.mock.ctrl.T.Helper()
	varargs := append([]any{arg0, arg1, arg2}, arg3...)
	call := mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "HandleProcessingError", reflect.TypeOf((*MockRPCAPI)(nil).HandleProcessingError), varargs...)
	return &MockRPCAPIHandleProcessingErrorCall{Call: call}
}

// MockRPCAPIHandleProcessingErrorCall wrap *gomock.Call
type MockRPCAPIHandleProcessingErrorCall struct {
	*gomock.Call
}

// Return rewrite *gomock.Call.Return
func (c *MockRPCAPIHandleProcessingErrorCall) Return() *MockRPCAPIHandleProcessingErrorCall {
	c.Call = c.Call.Return()
	return c
}

// Do rewrite *gomock.Call.Do
func (c *MockRPCAPIHandleProcessingErrorCall) Do(f func(*zap.Logger, string, error, ...fieldz.Field)) *MockRPCAPIHandleProcessingErrorCall {
	c.Call = c.Call.Do(f)
	return c
}

// DoAndReturn rewrite *gomock.Call.DoAndReturn
func (c *MockRPCAPIHandleProcessingErrorCall) DoAndReturn(f func(*zap.Logger, string, error, ...fieldz.Field)) *MockRPCAPIHandleProcessingErrorCall {
	c.Call = c.Call.DoAndReturn(f)
	return c
}

// Log mocks base method.
func (m *MockRPCAPI) Log() *zap.Logger {
	m.ctrl.T.Helper()
	ret := m.ctrl.Call(m, "Log")
	ret0, _ := ret[0].(*zap.Logger)
	return ret0
}

// Log indicates an expected call of Log.
func (mr *MockRPCAPIMockRecorder) Log() *MockRPCAPILogCall {
	mr.mock.ctrl.T.Helper()
	call := mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "Log", reflect.TypeOf((*MockRPCAPI)(nil).Log))
	return &MockRPCAPILogCall{Call: call}
}

// MockRPCAPILogCall wrap *gomock.Call
type MockRPCAPILogCall struct {
	*gomock.Call
}

// Return rewrite *gomock.Call.Return
func (c *MockRPCAPILogCall) Return(arg0 *zap.Logger) *MockRPCAPILogCall {
	c.Call = c.Call.Return(arg0)
	return c
}

// Do rewrite *gomock.Call.Do
func (c *MockRPCAPILogCall) Do(f func() *zap.Logger) *MockRPCAPILogCall {
	c.Call = c.Call.Do(f)
	return c
}

// DoAndReturn rewrite *gomock.Call.DoAndReturn
func (c *MockRPCAPILogCall) DoAndReturn(f func() *zap.Logger) *MockRPCAPILogCall {
	c.Call = c.Call.DoAndReturn(f)
	return c
}

// PollWithBackoff mocks base method.
func (m *MockRPCAPI) PollWithBackoff(arg0 retry.PollConfig, arg1 retry.PollWithBackoffFunc) error {
	m.ctrl.T.Helper()
	ret := m.ctrl.Call(m, "PollWithBackoff", arg0, arg1)
	ret0, _ := ret[0].(error)
	return ret0
}

// PollWithBackoff indicates an expected call of PollWithBackoff.
func (mr *MockRPCAPIMockRecorder) PollWithBackoff(arg0, arg1 any) *MockRPCAPIPollWithBackoffCall {
	mr.mock.ctrl.T.Helper()
	call := mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "PollWithBackoff", reflect.TypeOf((*MockRPCAPI)(nil).PollWithBackoff), arg0, arg1)
	return &MockRPCAPIPollWithBackoffCall{Call: call}
}

// MockRPCAPIPollWithBackoffCall wrap *gomock.Call
type MockRPCAPIPollWithBackoffCall struct {
	*gomock.Call
}

// Return rewrite *gomock.Call.Return
func (c *MockRPCAPIPollWithBackoffCall) Return(arg0 error) *MockRPCAPIPollWithBackoffCall {
	c.Call = c.Call.Return(arg0)
	return c
}

// Do rewrite *gomock.Call.Do
func (c *MockRPCAPIPollWithBackoffCall) Do(f func(retry.PollConfig, retry.PollWithBackoffFunc) error) *MockRPCAPIPollWithBackoffCall {
	c.Call = c.Call.Do(f)
	return c
}

// DoAndReturn rewrite *gomock.Call.DoAndReturn
func (c *MockRPCAPIPollWithBackoffCall) DoAndReturn(f func(retry.PollConfig, retry.PollWithBackoffFunc) error) *MockRPCAPIPollWithBackoffCall {
	c.Call = c.Call.DoAndReturn(f)
	return c
}

// MockAPI is a mock of API interface.
type MockAPI struct {
	ctrl     *gomock.Controller
	recorder *MockAPIMockRecorder
}

// MockAPIMockRecorder is the mock recorder for MockAPI.
type MockAPIMockRecorder struct {
	mock *MockAPI
}

// NewMockAPI creates a new mock instance.
func NewMockAPI(ctrl *gomock.Controller) *MockAPI {
	mock := &MockAPI{ctrl: ctrl}
	mock.recorder = &MockAPIMockRecorder{mock}
	return mock
}

// EXPECT returns an object that allows the caller to indicate expected use.
func (m *MockAPI) EXPECT() *MockAPIMockRecorder {
	return m.recorder
}

// HandleProcessingError mocks base method.
func (m *MockAPI) HandleProcessingError(arg0 context.Context, arg1 *zap.Logger, arg2 string, arg3 error, arg4 ...fieldz.Field) {
	m.ctrl.T.Helper()
	varargs := []any{arg0, arg1, arg2, arg3}
	for _, a := range arg4 {
		varargs = append(varargs, a)
	}
	m.ctrl.Call(m, "HandleProcessingError", varargs...)
}

// HandleProcessingError indicates an expected call of HandleProcessingError.
func (mr *MockAPIMockRecorder) HandleProcessingError(arg0, arg1, arg2, arg3 any, arg4 ...any) *MockAPIHandleProcessingErrorCall {
	mr.mock.ctrl.T.Helper()
	varargs := append([]any{arg0, arg1, arg2, arg3}, arg4...)
	call := mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "HandleProcessingError", reflect.TypeOf((*MockAPI)(nil).HandleProcessingError), varargs...)
	return &MockAPIHandleProcessingErrorCall{Call: call}
}

// MockAPIHandleProcessingErrorCall wrap *gomock.Call
type MockAPIHandleProcessingErrorCall struct {
	*gomock.Call
}

// Return rewrite *gomock.Call.Return
func (c *MockAPIHandleProcessingErrorCall) Return() *MockAPIHandleProcessingErrorCall {
	c.Call = c.Call.Return()
	return c
}

// Do rewrite *gomock.Call.Do
func (c *MockAPIHandleProcessingErrorCall) Do(f func(context.Context, *zap.Logger, string, error, ...fieldz.Field)) *MockAPIHandleProcessingErrorCall {
	c.Call = c.Call.Do(f)
	return c
}

// DoAndReturn rewrite *gomock.Call.DoAndReturn
func (c *MockAPIHandleProcessingErrorCall) DoAndReturn(f func(context.Context, *zap.Logger, string, error, ...fieldz.Field)) *MockAPIHandleProcessingErrorCall {
	c.Call = c.Call.DoAndReturn(f)
	return c
}
